Update Red Hat Copyright Notices
[nbdkit.git] / tests / test-retry-open.sh
blob6180444e7e1293f46d15c73a678372c94cea766a
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright Red Hat
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 source ./functions.sh
34 set -e
35 set -x
37 requires_plugin sh
38 requires qemu-io --version
40 # Note that test-retry.sh uses "retry-open-count", so choose
41 # another name here.
42 files="retry-open2-count"
43 rm -f $files
44 cleanup_fn rm -f $files
46 echo 0 > retry-open2-count
47 start_t=$SECONDS
49 # Create a custom plugin which will test retrying open.
50 nbdkit -v -U - \
51 sh - \
52 --filter=retry retry-delay=1 \
53 --run 'qemu-io -f raw -c "r -P0 0 512" $nbd || :' <<'EOF'
54 #!/usr/bin/env bash
55 case "$1" in
56 open)
57 # Count how many times the connection is (re-)opened.
58 read i < retry-open2-count
59 echo $((i+1)) > retry-open2-count
60 if test $i -lt 1; then
61 echo EIO >&2; exit 1
64 get_size) echo 512 ;;
65 pread) dd if=/dev/zero count=$3 iflag=count_bytes ;;
66 *) exit 2 ;;
67 esac
68 EOF
70 # In this test we should see 1 failure:
71 # first open FAILS
72 # retry and wait 1 second
73 # second open PASSES
75 # The minimum time for the test should be 1 second.
76 end_t=$SECONDS
77 if [ $((end_t - start_t)) -lt 1 ]; then
78 echo "$0: test ran too quickly"
79 exit 1
82 # Check the handle was opened 2 times (first open + one reopen).
83 read open_count < retry-open2-count
84 if [ $open_count -ne 2 ]; then
85 echo "$0: open-count ($open_count) != 2"
86 exit 1